/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    and Holger Zimmermann (http://pi3web.sourceforge.net/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Base/PIAlloc.h,v $
 * $Date: 2001/04/07 13:30:17 $
 *
 Description:
\*____________________________________________________________________________*/
//$HeaderTop:$

#ifndef PIALLOC_H_
#define PIALLOC_H_

#include <stdlib.h>

/*____________________________________________________________________________*\
 *
 Declarations:
\*____________________________________________________________________________*/
#if !defined(NDEBUG)

/* --- development build --- */
void PIBeforeNew( int iLine, const char *pFile );
void PIBeforeDelete( int iLine, const char *pFile );
void PIMark( int iLine, const char *pFile );
#define PI_NEW(x)		(PIBeforeNew(__LINE__,__FILE__), new x)
#define PI_DELETE(x)	(PIBeforeDelete(__LINE__,__FILE__), delete x)
#define PI_MARK			(PIMark(__LINE__,__FILE__))

#else

/* --- production build --- */
#define PI_NEW(x)		(new x)
#define PI_DELETE(x)	(delete x)
#define PI_MARK		


#endif

#endif	/* PIALLOC_H_ */

