/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    and Holger Zimmermann (http://pi3web.sourceforge.net/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/EnhPi3/Common.h,v $
 * $Date: 2001/04/07 13:30:18 $
 *
 Description:
	Functions and definitions common to all windows Pi3 stuff.

\*____________________________________________________________________________*/
/* $SourceTop:$ */

#ifndef COMMON_H_
#define COMMON_H_

#include <windows.h>

#include "Config.h"
#include "Dialogs.h"
#include "Control.h"
#include "ProgMan.h"

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
	Prototypes
\*____________________________________________________________________________*/
EXTERN_C int AD_configMain( HINSTANCE hInstance,
	int iArgc, const char *ppArgv[] );
EXTERN_C int AD_setupMain( HINSTANCE hInstance,
	int iArgc, const char *ppArgv[] );
EXTERN_C int AD_uninstallMain( HINSTANCE hInstance,
	int iArgc, const char *ppArgv[] );

/* --- Pi3 stuff --- */
EXTERN_C int Pi3_main( HINSTANCE hInstance,
	int iArgc, const char *ppArgv[] );
EXTERN_C int Pi3_startWindowing( HINSTANCE hInstance,
	const char *ppArgv[],
	void (* fnOnTermination )( void * ), void *pTerminationData );
EXTERN_C void Pi3_endWindowing();

/* --- Registry stuff --- */
EXTERN_C int REG_add();
EXTERN_C int REG_delete();

#endif /* COMMON_H_ */