/*____________________________________________________________________________*\

 Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    and Holger Zimmermann (http://pi3web.sourceforge.net/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/EnhPi3/Control.h,v $
 * $Date: 2001/04/07 13:30:18 $
 *
 Description:
	Functions to control execution of the Pi3Web server.

\*____________________________________________________________________________*/
//$SourceTop:$

#ifndef CONTROL_H_
#define CONTROL_H_

#include "PIString.h"

/*____________________________________________________________________________*\
 *
 Description:
	Functions and definition of commonconfiguration structures.
\*____________________________________________________________________________*/
typedef void *PTConfig;

extern PTConfig __pConfig;

#if defined(__cplusplus) && !defined(EXTERN_C)
#	define EXTERN_C	extern "C"
#endif

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
	Prototypes
\*____________________________________________________________________________*/
EXTERN_C int CTRL_isServiceInstalled( const char *pServiceName );
EXTERN_C int CTRL_installService( const char *pServiceName, const char *pPath );
EXTERN_C int CTRL_unInstallService( const char *pServiceName );
EXTERN_C int CTRL_isServiceRunning( const char *pServiceName );
EXTERN_C int CTRL_startService( const char *pServiceName );
EXTERN_C int CTRL_stopService( const char *pServiceName );
EXTERN_C int CTRL_isPi3Running( const char *pPi3NamedSemaphore );
EXTERN_C int CTRL_startPi3( const char *pCommandLine,
		const char *pPi3NamedSemaphore );
EXTERN_C int CTRL_stopPi3( const char *pPi3NamedSemaphore );
EXTERN_C void CTRL_semaphoreNameFromConfigPath( const char *pConfig,
	PIString &sSemaphore );
EXTERN_C int CTRL_openURL( HWND hWnd, const char *pURL );
EXTERN_C int CTRL_isStartupInstalled( const char *pSemaphoreName );
EXTERN_C int CTRL_installStartup( const char *pSemaphoreName, 
	const char *pCmdLine );
EXTERN_C int CTRL_unInstallStartup( const char *pSemaphore );

#endif /* CONTROL_H_ */

