/*____________________________________________________________________________*\
 *

 Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.

 These sources, libraries and applications are
 FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 as long as the following conditions are adhered to.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer. 

 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.

 3. Redistributions of any form whatsoever and all advertising materials 
    mentioning features must contain the following
    acknowledgment:
    "This product includes software developed by John Roy
    and Holger Zimmermann (http://pi3web.sourceforge.net/)."

 THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
 GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 OF THE POSSIBILITY OF SUCH DAMAGE.

 *____________________________________________________________________________*|
 *
 * $Source: /cvsroot/pi3web/Pi3Web_200/Source/Pi2API/_PILogic.cpp,v $
 * $Date: 2001/04/07 13:30:21 $
 *
 Description:
\*____________________________________________________________________________*/
//$SourceTop:$

#include "_PILogic.h"
#include "_PIObj.h"

/*____________________________________________________________________________*\
 *
 Function:
 Synopsis:
 Description:
	Quick internal conversion from object pointer to socket class
	pointer.
\*____________________________________________________________________________*/
inline const _PILogicClass *_2SC( PIObject *pObj )
{
	return (const _PILogicClass *)pObj->GetClass();
}

/*____________________________________________________________________________*\
 *
 Description:
	See API header files in ../piapi for full description
\*____________________________________________________________________________*/
PUBLIC_PIAPI int PILogic_execute( PIObject *pObj, int iArgc,
	const char *ppArgv[] )
{
	if ( !pObj ) { return PIAPI_EINVAL; };
	if ( _2SC(pObj)->GetType()!=_PIClass::LOGIC ) { return PIAPI_ERROR; };
	return _2SC(pObj)->Execute( pObj, iArgc, ppArgv );
}

