#!/usr/bin/perl

#*____________________________________________________________________________*\
#*
#
# Copyright (c) 1997-2001 John Roy, Holger Zimmermann. All rights reserved.
#
# These sources, libraries and applications are
# FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
# as long as the following conditions are adhered to.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. Redistributions of any form whatsoever and all advertising materials 
#    mentioning features must contain the following
#    acknowledgment:
#    "This product includes software developed by John Roy
#    and Holger Zimmermann (http://pi3web.sourceforge.net/)."
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHORS OR ITS CONTRIBUTORS BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
# GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
#*____________________________________________________________________________*|
#*
#* $Source: /cvsroot/pi3web/Pi3Web_200/Source/Scripts/gendef.pl,v $
#* $Date: 2001/04/07 13:30:22 $
#*
# Description:
# ARGV[0], the path to the directories with the files
# ARGV[1], the name of the file to create
# ARGV[2], the name library 
# other arguments are extensions of files to scan.	
#	NOTE:
#	note the extensions must be globbed by the shell running the 
#	perl script.
#	(LATER) under development.
#*____________________________________________________________________________*/

#/*___________________________________________________________________________*\
# Global declarations:
#\*___________________________________________________________________________*/
$path = shift;
$create_file = shift;
$libname = shift;
$debug = 0;

&do_main();

@symbols = ();

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub do_main
	{
	print $path.' '.$create_file.' '.$libname."\n" if $debug;
	foreach( @ARGV )
		{ &process_files( $_ ); };
	open( OUT, '>'.$create_file ) || die "Cannot open file $create_file: $!\n";
	print OUT ';/*___________________________________________________________________________*\
; *
;	*** AUTOMATICALLY GENERATED FILE: DO NOT MODIFY ***
;	
;	Module definition file for Win32 OS
;
;\*___________________________________________________________________________*/
;/* $SourceTop:$ */

LIBRARY ';
print OUT $libname.'
DESCRIPTION \'';
print OUT $libname.' Win32 Dynamic Link Library\'

EXPORTS
';
	foreach $sym ( @symbols )
		{ print OUT "\t$sym\n"; };
	print OUT '

';
	};

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#	(LATER), clean this up
#\*___________________________________________________________________________*/
sub process_files
	{
	if ( $^O =~ /MSWin32/ )
		{
		local( @args );
		foreach( @_ ) { push @args, glob; };
		@_=@args;
		};
	foreach( @_ )
        {
            $file = $_;
	      print $file if $debug;
		if ( open( INP, '<'.$file ) )
			{
			&process_file();
			close( INP );
			}
		else
			{ print "No files: $file\n"; };
        };
     };

#/*___________________________________________________________________________*\
# *
# Function:
# Synopsis:
# Description:
#\*___________________________________________________________________________*/
sub process_file
	{
	while( <INP> )
		{
		if ( /^PUBLIC_PIAPI / )
			{
			s/(.*)\(.*$/$1/;
			s/(.*)(\s|\*)(.*\w).*\n/$3/;
			push( @symbols, ( $_ ) );
			};
		};
	};

