
/*
 * Step10:
 * Program exit by killing main thread, check also stack unwinding.
 */

#include <iostream.h>
#include <stdlib.h>

#include "PiAPI.h"
#include "TestOS.h"

int iRet;

void Step10()
{
	iRet = -1;
	PISync *pSema = PIPlatform_allocLocalSemaphore( 1, 1 );
	if ( !pSema )
		{ FAILED(1); return; };
	if ( PISync_lock( pSema ) ) 
		{ FAILED(2); return; };
	if ( PISync_unlock( pSema ) ) 
		{ FAILED(3); return; };
	if ( PISync_delete( pSema ) )
		{ FAILED(4); return; };
	iRet = 0;
	OK;
}

int main()
{
	if ( PIPlatform_enter( "dummy", PIPLATFORM_VERSION_1_0, Step10 ) )
		{
		cout << "Platform_enter() failed." << endl;
		FAILED(99);
		exit( 1 );
		};

	return iRet;
}

